PStringDictionary< K > Class Template Reference

This template class maps the PAbstractDictionary to a specific key type and a `PString` data type. More...

`#include <pstring.h>`

Inheritance diagram for PStringDictionary< K >:

## Public Member Functions

Construction
| PStringDictionary ()
| Create a new, empty, dictionary. More...
Overrides from class PObject
virtual PObject * | Clone () const
| Make a complete duplicate of the dictionary. More...
New functions for class
const PString & | operator[] (const K &key) const
| Get the string contained in the dictionary at the `key` position. More...
PString | operator() (const K &key, const char *dflt=NULL) const
| Get the string contained in the dictionary at the `key` position. More...
PBoolean | Contains (const K &key) const
| Determine if the value of the object is contained in the hash table. More...
virtual PString * | RemoveAt (const K &key)
| Remove an object at the specified key. More...
virtual PString * | GetAt (const K &key) const
| Get the object at the specified key position. More...
virtual PBoolean | SetDataAt (PINDEX index, const PString &str)
| Set the data at the specified ordinal index position in the dictionary. More...
virtual PBoolean | SetAt (const K &key, const PString &str)
| Add a new object to the collection. More...
const K & | GetKeyAt (PINDEX index) const
| Get the key in the dictionary at the ordinal index position. More...
PString & | GetDataAt (PINDEX index) const
| Get the data in the dictionary at the ordinal index position. More...
Public Member Functions inherited from PAbstractDictionary
PINLINE | PAbstractDictionary ()
| Create a new, empty, dictionary. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual PINDEX | Insert (const PObject &key, PObject *obj)
| Insert a new object into the dictionary. More...
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)
| Insert a new object at the specified index. More...
virtual PObject * | RemoveAt (PINDEX index)
| Remove an object at the specified index. More...
virtual PBoolean | SetAt (PINDEX index, PObject *val)
| Set the object at the specified index to the new value. More...
virtual PObject * | GetAt (PINDEX index) const
| Get the object at the specified index position. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object. More...
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object. More...
virtual PBoolean | SetDataAt (PINDEX index, PObject *obj)
| Set the data at the specified ordinal index position in the dictionary. More...
virtual PBoolean | AbstractSetAt (const PObject &key, PObject *obj)
| Add a new object to the collection. More...
virtual PObject & | GetRefAt (const PObject &key) const
| Get the object at the specified key position. More...
virtual PObject * | AbstractGetAt (const PObject &key) const
| Get the object at the specified key position. More...
virtual void | AbstractGetKeys (PArrayObjects &keys) const
| Get an array containing all the keys for the dictionary. More...
Public Member Functions inherited from PHashTable
| PHashTable ()
| Create a new, empty, hash table. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two hash tables. More...
virtual PBoolean | SetSize (PINDEX newSize)
| This function is meaningless for hash table. More...
PINLINE PBoolean | AbstractContains (const PObject &key) const
| Determine if the value of the object is contained in the hash table. More...
virtual const PObject & | AbstractGetKeyAt (PINDEX index) const
| Get the key in the hash table at the ordinal index position. More...
virtual PObject & | AbstractGetDataAt (PINDEX index) const
| Get the data in the hash table at the ordinal index position. More...
Public Member Functions inherited from PCollection
| PCollection (PINDEX initialSize=0)
| Create a new collection. More...
virtual void | RemoveAll ()
| Remove all of the elements in the collection. More...
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection. More...
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
virtual PINDEX | GetSize () const
| Get the current size of the container. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions

| PStringDictionary (int dummy, const PStringDictionary *c)
Protected Member Functions inherited from PAbstractDictionary
PINLINE | PAbstractDictionary (int dummy, const PAbstractDictionary *c)
Protected Member Functions inherited from PCollection
PINLINE | PCollection (int dummy, const PCollection *coll)
| Constructor used in support of the Clone() function. More...
Protected Member Functions inherited from PContainer
| PContainer (int dummy, const PContainer *cont)
| Constructor used in support of the Clone() function. More...
| PContainer (PContainerReference &reference)
| Construct using static PContainerReference. More...
virtual void | DestroyContents ()=0
| Destroy the container contents. More...
virtual void | AssignContents (const PContainer &c)
| Copy the container contents. More...
void | CopyContents (const PContainer &c)
| Copy the container contents. More...
void | CloneContents (const PContainer *src)
| Create a duplicate of the container contents. More...
void | Destruct ()
| Internal function called from container destructors. More...
virtual void | DestroyReference ()
| Destroy the PContainerReference instance. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Additional Inherited Members

Public Types inherited from PHashTable
typedef PHashTableElement | Element
typedef PHashTableInfo | Table
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Public Attributes inherited from PHashTable
PHashTableInfo * | hashTable
Protected Attributes inherited from PContainer
PContainerReference * | reference

## Detailed Description

### template<class K>
class PStringDictionary< K >

This template class maps the PAbstractDictionary to a specific key type and a `PString` data type.

The functions in this class primarily do all the appropriate casting of types.

Note that if templates are not used the `PDECLARE_STRING_DICTIONARY` macro will simulate the template instantiation.

## Constructor & Destructor Documentation

## PStringDictionary() [1/2]

template<class K>

PStringDictionary< K >::PStringDictionary | ( |  | ) |

inline

Create a new, empty, dictionary.

Note that by default, objects placed into the dictionary will be deleted when removed or when all references to the dictionary are destroyed.

## PStringDictionary() [2/2]

template<class K>

PStringDictionary< K >::PStringDictionary | ( | int | dummy,
|  | const PStringDictionary< K > * | c
| ) |  |

inline protected

## Member Function Documentation

## Clone()

template<class K>

virtual PObject* PStringDictionary< K >::Clone | ( |  | ) | const

inline virtual

Make a complete duplicate of the dictionary.

Note that all objects in the array are also cloned, so this will make a complete copy of the dictionary.

Reimplemented from PObject.

References PNEW.

## Contains()

template<class K>

PBoolean PStringDictionary< K >::Contains | ( | const K & | key | ) | const

inline

Determine if the value of the object is contained in the hash table.

The object values are compared, not the pointers. So the objects in the collection must correctly implement the `PObject::Compare()` function. The hash table is used to locate the entry.

Returns
  true if the object value is in the dictionary.

Referenced by PStringOptions::Contains().

## GetAt()

template<class K>

virtual PString* PStringDictionary< K >::GetAt | ( | const K & | key | ) | const

inline virtual

Get the object at the specified key position.

If the key was not in the collection then NULL is returned.

Returns
  pointer to object at the specified key.

Referenced by PStringOptions::GetAt().

## GetDataAt()

template<class K>

PString& PStringDictionary< K >::GetDataAt | ( | PINDEX | index | ) | const

inline

Get the data in the dictionary at the ordinal index position.

The ordinal position in the dictionary is determined by the hash values of the keys and the order of insertion.

The last key/data pair is remembered by the class so that subseqent access is very fast.

Returns
  reference to data at the index position.

## GetKeyAt()

template<class K>

const K& PStringDictionary< K >::GetKeyAt | ( | PINDEX | index | ) | const

inline

Get the key in the dictionary at the ordinal index position.

The ordinal position in the dictionary is determined by the hash values of the keys and the order of insertion.

The last key/data pair is remembered by the class so that subseqent access is very fast.

Returns
  reference to key at the index position.

## operator()()

template<class K>

PString PStringDictionary< K >::operator() | ( | const K & | key,
|  | const char * | dflt = `NULL`
| ) |  | const

inline

Get the string contained in the dictionary at the `key` position.

The hash table is used to locate the data quickly via the hash function provided by the key.

The last key/data pair is remembered by the class so that subseqent access is very fast.

This function returns the `dflt` value if there is no data at the key position.

Returns
  reference to the object indexed by the key.

References PBaseArray< T >::GetAt(), and PString::PString().

## operator[]()

template<class K>

const PString& PStringDictionary< K >::operator[] | ( | const K & | key | ) | const

inline

Get the string contained in the dictionary at the `key` position.

The hash table is used to locate the data quickly via the hash function provided by the key.

The last key/data pair is remembered by the class so that subseqent access is very fast.

This function asserts if there is no data at the key position.

Returns
  reference to the object indexed by the key.

## RemoveAt()

template<class K>

virtual PString* PStringDictionary< K >::RemoveAt | ( | const K & | key | ) |

inline virtual

Remove an object at the specified key.

The returned pointer is then removed using the `SetAt()` function to set that key value to NULL. If the `AllowDeleteObjects` option is set then the object is also deleted.

Returns
  pointer to the object being removed, or NULL if the key was not present in the dictionary. If the dictionary is set to delete objects upon removal, the value -1 is returned if the key existed prior to removal rather than returning an illegal pointer

References PContainerReference::deleteObjects, PBaseArray< T >::GetAt(), and PContainer::reference.

Referenced by PStringOptions::RemoveAt().

## SetAt()

template<class K>

virtual PBoolean PStringDictionary< K >::SetAt | ( | const K & | key,
|  | const PString & | str
| ) |  |

inline virtual

Add a new object to the collection.

If the objects value is already in the dictionary then the object is overrides the previous value. If the AllowDeleteObjects option is set then the old object is also deleted.

The object is placed in the an ordinal position dependent on the keys hash function. Subsequent searches use the has function to speed access to the data item.

Returns
  true if the object was successfully added.

References PNEW, and PString::PString().

Referenced by PMIMEInfo::SetAssociation(), and PStringOptions::SetAt().

## SetDataAt()

template<class K>

virtual PBoolean PStringDictionary< K >::SetDataAt | ( | PINDEX | index,
|  | const PString & | str
| ) |  |

inline virtual

Set the data at the specified ordinal index position in the dictionary.

The ordinal position in the dictionary is determined by the hash values of the keys and the order of insertion.

Returns
  true if the new object could be placed into the dictionary.

References PNEW, PString::PString(), and PAbstractDictionary::SetDataAt().

The documentation for this class was generated from the following file:

- pstring.h